function foxfm_team_training(doc)
{
	try 
	{
		if(doc.location.href.match("010_mannschaft/training.php")) 
		{
			// get all tables --> tag: 'table'
			var tbl = doc.getElementsByTagName("table");			
			
			// alert(doc.location.href);
			// Following array 
			// Training: 	1 - Erholung
			// 				2 - Torwart
			// 				3 - Taktik
			// 				4 - Kondition
			// 				5 - Trainingsspiel
			// 				6 - Technik
			// 				7 - Schnelligkeit
			// Position: 	1 - TW
			// 				2 - LV, LMD, RMD, RV, VS
			// 				3 - LM, ZM, DM, RM
			// 				4 - LS, MS, RS
			// 		==> Index = Training x Position
			
			// Following arrays (tp, ep, fp) have following meaning:
			// 1st element --> value for player up to 26 years old
			// 2nd element --> value for player up to 28 years old
			// 3rd element --> value for player up to 30 years old
			// 4th element --> value for player up to 32 years old
			// 5th element --> value for player up to 34 years old
			// 6th element --> value for player up to 37 years old
			// Week-training - 2 dimensional array
			var wt = [
				// Erholung
				[38, 5, 0],
				[38, 5, 0],
				[38, 5, 0],
				[38, 5, 0],
				// Torwart
				[34, -2, 5],
				[34, -2, 1],
				[34, -2, 1],
				[34, -2, 1],
				// Taktik
				[32, -1, 1],
				[32, -1, 3],
				[32, -1, 1],
				[32, -1, 1],
				// Kondition
				[38, -3, 1],
				[38, -3, 1],
				[38, -3, 2],
				[38, -3, 1],
				// Trainingsspiel
				[30, -3, 2],
				[30, -3, 2],
				[30, -3, 2],
				[30, -3, 2],
				// Technik
				[28, -2, 1],
				[28, -2, 1],
				[28, -2, 3],
				[28, -2, 2],
				// Schnelligkeit
				[26, -2, 2],
				[26, -2, 2],
				[26, -2, 3],
				[26, -2, 4],
			];
			// save the type of the training of the correspondent day
			// --> 0 - 'Monday-1', 1 - 'Monday-2', 2 - 'Tuesday-1' etc
			var weekTraining = new Array(10);
			// get all trainigs radio buttons by name --> name: 'trl'
			var trl = doc.getElementsByName("trl");
			// define array holding training points for one player - tp, ep and fp
			var playerTrainingPoints = new Array();
			var ignoreRow = -1;
			
			// get table of the team --> look for "Pos" and "Spielername"
			var teamTableIndex = findTable(tbl, "Pos", "Spielername");
			if(teamTableIndex>=0)
			{
				tableChangeAttributes(tbl[teamTableIndex], "");
				// alert("found training-team table");
				// Extend table of team regarding new training information
				// --> Freshness, Trainings and Expierence points
				addCell(tbl[teamTableIndex], 0, -1, null, "<p align=center><a class=\"info\">Tr-Er<span>Erfahrungspunkte Training</span></a></p>", "top", "", "");					
				addCell(tbl[teamTableIndex], 0, -1, null, "<p align=center><a class=\"info\">Tr-Tr<span>Trainingspunkte Training</span></a></p>", "top", "", "");
				addCell(tbl[teamTableIndex], 0, -1, null, "<p align=center><a class=\"info\">Tr-Fr<span>Frischepunkte Training</span></a></p>", "top", "", "");
				
				addCell(tbl[teamTableIndex], 0, -1, null, "<p align=center><a class=\"info\">Neu-Er<span>GESAMT Erfahrungspunkte nach dem Training</span></a></p>", "top", "", "");
				addCell(tbl[teamTableIndex], 0, -1, null, "<p align=center><a class=\"info\">Neu-Tr<span>GESAMT Trainingspunkte nach dem Training</span></a></p>", "top", "", "");
				addCell(tbl[teamTableIndex], 0, -1, null, "<p align=center><a class=\"info\">Neu-Fr<span>GESAMT Frischepunkte nach dem Training</span></a></p>", "top", "", "");
				addCell(tbl[teamTableIndex], 0, -1, null, "<p align=center><a class=\"info\">Neu-Awp<span>GESAMT Aufwertungspunkte nach dem Training</span></a></p>", "top", "", "");
										
				// find the row where to start after --> row of first player
				var row = findRow(tbl[teamTableIndex], "Pos", "Spielername");
				if(row >= 0)
				{
					for(var i=1; i<=weekTraining.length; i++)
					{
						weekTraining[i-1] = getValueOfTrainingTypeOfDay(doc.getElementsByName("tid" + i));
					}
					// iterate through the team
					for(var j=row+1; j<tbl[teamTableIndex].rows.length; j++)
					{
						// get the name of the player
						try
						{
							playerName = tbl[teamTableIndex].rows[j].getElementsByTagName("a")[0].innerHTML;
						} catch(e)
						{
							playerName = "";
							ignoreRow = j;
						}
						/* check if the current row of the training table contains a player 
						   --> necessary for the Plus-Acc as there is a last summary row */
						if(playerName)
						{
							// get the position of the player
							playerPos = tbl[teamTableIndex].rows[j].cells[0].innerHTML;
							// get the name of the player
							playerName = tbl[teamTableIndex].rows[j].getElementsByTagName("a")[0].innerHTML;
							// get the age of the player
							playerAge = tbl[teamTableIndex].rows[j].cells[2].innerHTML;
							// check if the player is activated for the correspondent training
							playerActivated = tbl[teamTableIndex].rows[j].getElementsByTagName("input")[0].checked;
							// get the expierience points of the player
							var playerEps = getNumberFromString(tbl[teamTableIndex].rows[j].cells[4].getElementsByTagName("font")[0].innerHTML);
							// get the training points of the player
							var playerTps = getNumberFromString(tbl[teamTableIndex].rows[j].cells[5].getElementsByTagName("font")[0].innerHTML);
							// get the freshness of the player
							var playerFps = tbl[teamTableIndex].rows[j].cells[6].getElementsByTagName("font")[0].innerHTML;
							
							// assign the correspondent value of the position 
							// --> used to calculate the index for week-training array
							posVal = getPlayerPosVal(playerPos, playerName);								
							if(playerActivated)
							{
								if(trl[0].checked)
								{
									playerTrainingPoints = getWeekTrainingPoints(wt, weekTraining, playerAge, playerEps, playerTps, playerFps);
								} else {
									if(playerAge<32)
									{
										for(i=1; i<trl.length; i++)
										{
											if(trl[i].checked)
											{
												playerTrainingPoints = getTrainingCampPoints(trl[i].value, playerEps, playerTps, playerFps);
											}
										}
									} else {
										playerTrainingPoints["fp"] = parseInt(playerFps) + 10 * 5;
										playerTrainingPoints["tp"] = parseInt(playerTps);
										playerTrainingPoints["ep"] = parseInt(playerEps);
									}
								}
							} else {
								// alert("player not activated");
								playerTrainingPoints["fp"] = parseInt(playerFps) + 10 * 5;
								playerTrainingPoints["tp"] = parseInt(playerTps);
								playerTrainingPoints["ep"] = parseInt(playerEps);
							}
							if(playerTrainingPoints["fp"] > 127)
							{
								playerTrainingPoints["fp"] = 127;
							}
		
							var playerAWPsNew = getAWP(playerTrainingPoints["ep"], playerTrainingPoints["tp"]);						
							
							addCell(tbl[teamTableIndex], j, -1, null, playerTrainingPoints["ep"] - playerEps, "", "right", "");
							addCell(tbl[teamTableIndex], j, -1, null, playerTrainingPoints["tp"] - playerTps, "", "right", "");
							addCell(tbl[teamTableIndex], j, -1, null, playerTrainingPoints["fp"] - playerFps, "", "right", "");
							addCell(tbl[teamTableIndex], j, -1, null, playerTrainingPoints["ep"], "", "right", "");
							addCell(tbl[teamTableIndex], j, -1, null, playerTrainingPoints["tp"], "", "right", "");							
							addCell(tbl[teamTableIndex], j, -1, null, playerTrainingPoints["fp"], "", "right", "");								
							addCell(tbl[teamTableIndex], j, -1, null, playerAWPsNew, "", "right", "");
						}
					} // for()
					
					var awpCol;
					awpCol = parseInt(findColumn(tbl[teamTableIndex].rows[row].cells, "Neu-Awp"));
					var lvlCol;
					lvlCol = parseInt(findColumn(tbl[teamTableIndex].rows[row].cells, "St"));
					if(awpCol >= 0) 
					{
						// alert("calling: addCurrLvlAwpsDiffNextLvl(" + row + ", " + awpCol + ", " + (awpCol+1) + ", " + (awpCol+2) + ", " + (awpCol+3) + ")");
						addCurrLvlAwpsDiffNextLvl(tbl[teamTableIndex], row, ignoreRow, lvlCol, null, null, awpCol, (awpCol+1), (awpCol+2), (awpCol+3));
					} // if()
				} // if()
			}
			
			var addAllAttendanceCheckbox	= prefBranchOFMFunctionSettings.get("training.addallattendancecheckbox");
			var addFreshnessFilter			= prefBranchOFMFunctionSettings.get("training.addfreshnessfilter");
						
			if(addAllAttendanceCheckbox || addFreshnessFilter)
			{
				var freshnessTableNumber	= getFreshnessTableNumber(doc);			
				var freshnessTableContent	= tbl[freshnessTableNumber];
				if(freshnessTableContent)
				{
					freshnessTableContent.insertRow(1);
					for(var i=0; i<freshnessTableContent.rows[0].cells.length; i++)
					{
						freshnessTableContent.rows[1].insertCell(i);
						freshnessTableContent.rows[1].cells[i].setAttribute("class", "top");
					}
				}
				
				var freshnessColumnNumber	= getFreshnessColumnNumber(doc);
				if(addFreshnessFilter && freshnessColumnNumber)
				{
					addFilterFreshness(doc, freshnessTableContent, 1, freshnessColumnNumber);
				}			
				
				var trainingAttendanceColumnNumber = getTrainingAttendanceColumnNumber(doc);
				if(addAllAttendanceCheckbox && trainingAttendanceColumnNumber)
				{
					addSelectAll(doc, freshnessTableContent, 1, trainingAttendanceColumnNumber);
				}
			}
		}
	} catch (e) {
		errorMessage(e);
	}
}

function addFilterFreshness(doc, table, row, column)
{
	try
	{
		infoMessage(2, "addFilterFreshness(): started");
		
		var newSelect = createDropdown(doc, "dropdownfilterfreshness", null, null, "{width:50px;}", "'Spieler-Frische'>'Auswahl', dann Training aktiviert", null);
		for(var i=0;i<127;i++)
		{
			var newOption=doc.createElement('option');
			newOption.text=i;
			newSelect.add(newOption, null);
		}
		newSelect.addEventListener("change", function(event){event_tt_freshnessFilter(event, doc)}, false );
		newSelect.addEventListener("keyup", function(event){event_tt_freshnessFilter(event, doc)}, false );
		table.rows[row].cells[column].appendChild(newSelect);
	} catch (e) {
		errorMessage(e);
	}
}

function event_tt_freshnessFilter(event, document)
{
	try
	{		
		var freshnessThreshold			= getNumberFromString(event.target.value);
		var freshnessColumn				= foxfm_tt_getFreshnessCol(document);
		var trainingAttendanceInputs	= foxfm_tt_getTrainingAttendanceCol(document);
		
		infoMessage(4, "event_tt_freshnessFilter(): freshness threshold: " + freshnessThreshold);

		if(freshnessColumn && trainingAttendanceInputs && freshnessThreshold && (freshnessColumn.length == trainingAttendanceInputs.length))
		{	
			for(var i=0; i<freshnessColumn.length; i++)
			{
				if(trainingAttendanceInputs[i])
				{
					if(freshnessColumn[i]>freshnessThreshold)
					{
						trainingAttendanceInputs[i].checked = true;
					}
					else					
					{
						trainingAttendanceInputs[i].checked = false;
					}				
				}
			}
		}
		else
		{
			errorMessage("Could not clearly determine the row containing the freshness of the team training table.");
		}
	} catch (e) {
		errorMessage(e);
	}
}

function foxfm_tt_getFreshnessCol(document)
{
	var aFreshness = null;
	try
	{
		infoMessage(4, "foxfm_tt_getFreshnessCol(): started");

		var aColumn			= getColumnContentByXPATH(document, '//./table/tbody/tr/td/a/.[@href="?orderby=7"]');
		var freshness		= null;
		aFreshness			= new Array();
		for(var i=0; i<aColumn.length; i++)
		{
			freshness		= getNumberFromNode(aColumn[i]);
			if(freshness)
			{
				aFreshness.push(freshness);
			}
		}

		infoMessage(4, "foxfm_tt_getFreshnessCol(): column containing the freshness: " + aFreshness);
	} catch (e) {
		errorMessage(e);
	}
	return aFreshness;
}

function foxfm_tt_getTrainingAttendanceCol(document)
{
	var aTrainingAttendance = null;
	try
	{
		infoMessage(4, "foxfm_tt_getTrainingAttendanceCol(): started");

		var aColumn			= getColumnContentByXPATH(document, '//./table/tbody/tr/td/a/.[@href="?orderby=8"]');
		var attendance		= null;
		aTrainingAttendance	= new Array();
		
		// ignore first two rows
		// 1st row - header of the column
		// 2nd row - contains the "All Training attendance" input/checkbox
		for(var i=2; i<aColumn.length; i++)
		{
			var input = aColumn[i].getElementsByTagName("input");
			// infoMessage(0,input.id);

			// if(input && input.id != "chkboxTrainingAttendanceAll")
			if(input)
			{
				aTrainingAttendance.push(input[0]);
			}
		}

		infoMessage(4, "foxfm_tt_getTrainingAttendanceCol(): column containing the training attendance: " + aTrainingAttendance);
	} catch (e) {
		errorMessage(e);
	}
	return aTrainingAttendance;
}

function addSelectAll(doc, table, row, column)
{
	try
	{
		infoMessage(2, "addSelectAll(): started");
		var selectAll	= createCheckbox(doc, "chkboxTrainingAttendanceAll", null, null, null, "Aktiviere/Deaktiviere Training fuer alle Spieler", null, "", null);
		selectAll.addEventListener("change", function(event){event_tt_setAllTrainingAttendance(event, doc)}, false );
		table.rows[row].cells[column].appendChild(selectAll);
	} catch (e) {
		errorMessage(e);
	}
}

function event_tt_setAllTrainingAttendance(event, document)
{
	try 
	{
		var checked	= event.target.checked;
		var inputs	= foxfm_tt_getTrainingAttendanceCol(document);

		for(var i=0; i<inputs.length; i++)
		{
			if(inputs[i].getAttribute("type").match("checkbox"))
			{
				inputs[i].checked = checked;
			}
		}	
	} catch (e) {
		errorMessage(e);
	}
}

function getValueOfTrainingTypeOfDay(day)
{
for(var i=0; i<day.length; i++)
{
	// alert(day[i].checked);
	// check which type of training is activated
	if(day[i].checked)
	{
		// this switch-case is only for debugging
		switch(i)
		{
			case 0:
				// alert("Erholung");
				break;
			case 1:
				// alert("Torwart");
				break;
			case 2:
				// alert("Taktik");
				break;
			case 3:
				// alert("Kondition");
				break;
			case 4:
				// alert("Trainingsspiel");
				break;
			case 5:
				// alert("Technik");
				break;
			case 6:
				// alert("Schnelligkeit");
				break;
			default:
				alert("Es konnte das Montagstraining nicht festgestellt werden.");
				return -1;
				break;
		}			
		// return the number of the activated type of training
		return i;
	}
	}
}

function getTrainingCampPoints(trainingCampValue, playerEps, playerTps, playerFps)
{
	var trainingPoints = new Array(3);
	trainingPoints["ep"] = parseInt(playerEps);
	trainingPoints["tp"] = parseInt(playerTps);
	trainingPoints["fp"] = parseInt(playerFps);
	
	// if player freshness is below 50 points don't count the
	// current training and add 50 freshness points instead
	if(trainingPoints["fp"] < 50)
	{
		trainingPoints["fp"] = trainingPoints["fp"] + 10 * 5;
	} else {
		switch(trainingCampValue)
		{
			// 'normal' week training
			case '1': 
				// value of the week training
				// --> Week training should be evaluated before
				// ==> This function should not be called with a value of '1'
				break;
			case '2': 
				// alert("Turnier: International");
				trainingPoints["tp"] += 50;
				trainingPoints["ep"] += 0;
				trainingPoints["fp"] += -55;
				break;
			case '3': 
				// alert("Turnier: Europa");
				trainingPoints["ep"] += 40;
				trainingPoints["tp"] += 0;
				trainingPoints["fp"] += -50;
				break;
			case '4': 
				// alert("Turnier: National");
				trainingPoints["ep"] += 30;
				trainingPoints["tp"] += 0;
				trainingPoints["fp"] += -40;
				break;
			case '5': 
				// alert("Turnier: Lokales Turnier");
				trainingPoints["ep"] += 20;
				trainingPoints["tp"] += 0;
				trainingPoints["fp"] += -35;
				break;
			case '6': 
				// alert("Turnier: Hallenturnier");
				trainingPoints["ep"] += 10;
				trainingPoints["tp"] += 0;
				trainingPoints["fp"] += -30;
				break;
			case '7': 
				// alert("Trainingslager: Brasilien");
				trainingPoints["ep"] += 0;
				trainingPoints["tp"] += 200;
				trainingPoints["fp"] += -50;
				break;
			case '8': 
				// alert("Trainingslager: England");
				trainingPoints["ep"] += 0;
				trainingPoints["tp"] += 150;
				trainingPoints["fp"] += -40;
				break;
			case '9': 
				// alert("Trainingslager: Mittelmeer");
				trainingPoints["ep"] += 0;
				trainingPoints["tp"] += 100;
				trainingPoints["fp"] += -35;
				break;
			case '10': 
				// alert("Trainingslager: Alpen");
				trainingPoints["ep"] += 0;
				trainingPoints["tp"] += 75;
				trainingPoints["fp"] += -30;
				break;
			case '11': 
				// alert("Trainingslager: Holland");
				trainingPoints["ep"] += 0;
				trainingPoints["tp"] += 50;
				trainingPoints["fp"] += -25;
				break;
			default:
				break;
		} // switch()
	}
	return trainingPoints;
}

function getWeekTrainingPoints(wt, weekTraining, playerAge, playerEps, playerTps, playerFps)
{
	var trainingPoints = new Array(3);
	trainingPoints["ep"] = parseInt(playerEps);
	trainingPoints["tp"] = parseInt(playerTps);
	trainingPoints["fp"] = parseInt(playerFps);
	// ==> Calculate TP and FP of the week training dependent on the 
	// - player's current freshness
	// - player's age
	// - player's position
	// - acitvated type of training
	// iterate through the week training
	for(var i=0; i<weekTraining.length; i++)
	{
		// if player freshness is below 50 points don't count the
		// current training and add 5 freshness points instead
		if(trainingPoints["fp"] < 50)
		{
			trainingPoints["fp"] = trainingPoints["fp"] + 5;
		} else {
			var wtRowIndex = (weekTraining[i] * 4) + posVal;
			// alert("Training type: " + weekTraining[i] + ", wtRowIndex: " + wtRowIndex);
			if(playerAge > wt[wtRowIndex][0])
			{
				// ==> Player is to old for activated type of training												
				// Add general freshness points
				trainingPoints["fp"] = trainingPoints["fp"] - 3;
				// Add general training points
				trainingPoints["tp"] = trainingPoints["tp"] + 1;											
			} else {
				// add the freshness points of the activated type of training
				// --> column 2
				trainingPoints["fp"] = trainingPoints["fp"] + wt[wtRowIndex][1];
				// add the training points of the activated type of training 
				// --> column 3
				trainingPoints["tp"] = trainingPoints["tp"] + wt[wtRowIndex][2];
			}												
		}
	}
	return trainingPoints;
}

function getPlayerPosVal(playerPos, playerName)
{
	var posVal = -1;
	switch(playerPos)
	{
		// Value of keepe position: "TW"
		case 'TW':
			posVal = 0;
			break;
		// Value of defence position: "LV", "LMD", "RV", "RMD", "LIB" and "VS"
		case 'LV':
		case 'LMD':
		case 'RV':
		case 'RMD':
		case 'VS':
		case 'LIB':
			posVal = 1;
			break;
		// Value of centre position: "LM", "ZM", "DM", "RM"
		case 'LM':
		case 'ZM':
		case 'DM':
		case 'RM':
			posVal = 2;
			break;
		// Value of offence position: "LS", "MS", "RS"
		case 'LS':
		case 'MS':
		case 'RS':
			posVal = 3;
			break;
		default:
			posVal = -1;
			// FIXME: Print error message taken from the locals --> Position of player could not be detected
			//alert(&foxfm.locale.errormsg.teamtraining.nopos;);
			alert("Die Position eines Spielers konnte nich erkannt werden: " + playerName);
			break;
	}
	return posVal;
}
